
/*******************************************************************************
* DDR ECC component and parameters
*******************************************************************************/

Folder FOLDER_ppc405_0_drv_DDR {
  NAME       DDR ECC Core
  SYNOPSIS   DDR ECC Core
  _CHILDREN  FOLDER_ppc405_0_drv_CSP
}

Component INCLUDE_XDDR {
  NAME       DDR ECC
  SYNOPSIS   Xilinx DDR ECC driver
  REQUIRES   
  _CHILDREN  FOLDER_ppc405_0_drv_DDR
}

/*******************************************************************************
* VxWorks attach point is in the PERIPHERALS folder
*******************************************************************************/

Folder FOLDER_ppc405_0_drv_CSP {
  NAME       Xilinx ppc405_0_drv CSP
  SYNOPSIS   Chip Support Package for the Xilinx ppc405_0_drv FPGA
  _CHILDREN  FOLDER_PERIPHERALS
}



/*******************************************************************************
* Interrupt controller
*******************************************************************************/

Folder FOLDER_ppc405_0_drv_INTC {
  NAME       Interrupt controller Core
  SYNOPSIS   Interrupt controller Core
  _CHILDREN  FOLDER_ppc405_0_drv_CSP
}

Component INCLUDE_XINTC {
  NAME       INTC
  SYNOPSIS   Xilinx Interrupt controller
  REQUIRES   
  _CHILDREN  FOLDER_ppc405_0_drv_INTC
}

/*******************************************************************************
* OPB arbiter component and parameters
*******************************************************************************/

Folder FOLDER_ppc405_0_drv_OPBARB {
  NAME       OPB Arbiter
  SYNOPSIS   OPB Arbiter support
  _CHILDREN  FOLDER_ppc405_0_drv_CSP
}

Component INCLUDE_XOPBARB {
  NAME       OPB arbiter interface
  SYNOPSIS   OPB arbiter interface
  REQUIRES   
  _CHILDREN  FOLDER_ppc405_0_drv_OPBARB
}

/*******************************************************************************
* PLB arbiter component and parameters
*******************************************************************************/

Folder FOLDER_ppc405_0_drv_PLBARB {
  NAME       PLB Arbiter
  SYNOPSIS   PLB Arbiter support
  _CHILDREN  FOLDER_ppc405_0_drv_CSP
}

Component INCLUDE_XPLBARB {
  NAME       PLB arbiter interface
  SYNOPSIS   PLB arbiter interface
  REQUIRES   
  _CHILDREN  FOLDER_ppc405_0_drv_PLBARB
}

/*******************************************************************************
* Ethernet component and parameters
*******************************************************************************/

Folder FOLDER_ppc405_0_drv_TEMAC {
  NAME       Tri-Mode Ethernet Core
  SYNOPSIS   Tri-Mode Ethernet Core
  _CHILDREN  FOLDER_ppc405_0_drv_CSP
}

Component INCLUDE_XTEMAC {
  NAME       TEMAC
  SYNOPSIS   Xilinx Tri-Mode Ethernet driver
  REQUIRES   
  _CHILDREN  FOLDER_ppc405_0_drv_TEMAC
}


/*******************************************************************************
* Ethernet adapter
*******************************************************************************/

Component INCLUDE_XTEMAC_VXWORKS5_4 {
  NAME       TEMAC END
  SYNOPSIS   Xilinx Tri-Mode MAC END driver add-on 
  REQUIRES   INCLUDE_XTEMAC INCLUDE_END
  _CHILDREN  FOLDER_ppc405_0_drv_TEMAC
}

/*******************************************************************************
* UART component and parameters
*******************************************************************************/

Folder FOLDER_ppc405_0_drv_UARTNS550 {
  NAME       UART 16550 Core
  SYNOPSIS   UART 16550 Core
  _CHILDREN  FOLDER_ppc405_0_drv_CSP
}

Component INCLUDE_XUARTNS550 {
  NAME       UART 16550
  SYNOPSIS   Xilinx 16550 UART driver 
  REQUIRES   
  _CHILDREN  FOLDER_ppc405_0_drv_UARTNS550
}


/*******************************************************************************
* UART NS550 SIO adapter
*******************************************************************************/

Component INCLUDE_XUARTNS550_VXWORKS5_4 {
  NAME       UART 16550 SIO
  SYNOPSIS   Xilinx 16550 UART SIO driver add-on 
  REQUIRES   INCLUDE_XUARTNS550
  _CHILDREN  FOLDER_ppc405_0_drv_UARTNS550
}

