/* configNet.h - Network configuration header file */

/*******************************************************************************
   XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
   AS A COURTESY TO YOU, SOLELY FOR USE IN DEVELOPING PROGRAMS AND
   SOLUTIONS FOR XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE,
   OR INFORMATION AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
   APPLICATION OR STANDARD, XILINX IS MAKING NO REPRESENTATION
   THAT THIS IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
   AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
   FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
   WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
   IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
   REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
   INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
   FOR A PARTICULAR PURPOSE.

   (c) Copyright 2003 Xilinx Inc.
   All rights reserved.
*******************************************************************************/

/*
This file defines the END network configuration.
TODO - Update this file to suit your systems' architecture.
*/

/*
modification history
--------------------
01a,02jul03,rpm  Added tags to integrate the XGemac adapter
01b,18feb03,rmm  Updated for VxWorks 5.5
01c,04jun04,rmm  Added tags to integrate the XEmacLite adapter
01d,11may05,rmm  Added tags to integrate the XTemac adapter
*/

#ifndef INCconfigNeth
#define INCconfigNeth

#include "vxWorks.h"
#include "end.h"


/*
 * TODO - For each type of ethernet, include its header, load-string,
 * and load function which will be placed in the endDevTbl. The sample
 * below is for illustrative purposes only.
 */
#ifdef INCLUDE_XEMAC_VXWORKS5_4
#include "xemac_end_adapter.h"

IMPORT END_OBJ *XEmacEndAdapter_Load(char *, void *);
#endif

#ifdef INCLUDE_XGEMAC_VXWORKS5_4
#include "xgemac_end_adapter.h"

IMPORT END_OBJ *XGemacEndAdapter_Load(char *, void *);
#endif

#ifdef INCLUDE_XEMACLITE_VXWORKS5_4
#include "xemaclite_end_adapter.h"

IMPORT END_OBJ *XEmacLiteEndAdapter_Load(char *, void *);
#endif

#ifdef INCLUDE_XTEMAC_VXWORKS5_4
#include "xtemac_end_adapter.h"

IMPORT char XTemacLoadString0[];
IMPORT END_OBJ *XTemacEndAdapter_Load(char *, void *);
#endif

/*
 * TODO - For each type of ethernet, place its entry into the VxWorks
 * endDevTbl. The sample below is for illustrative purposes only.
 */
END_TBL_ENTRY endDevTbl [] =
{

#ifdef INCLUDE_XEMAC_VXWORKS5_4
#endif

#ifdef INCLUDE_XGEMAC_VXWORKS5_4
#endif

#ifdef INCLUDE_XEMACLITE_VXWORKS5_4
#endif

#ifdef INCLUDE_XTEMAC_VXWORKS5_4
    {0, XTemacEndAdapter_Load, XTemacLoadString0, TRUE, NULL, FALSE},
#endif
    
    {0, END_TBL_END, NULL, 0, NULL, FALSE},
};

#endif /* INCconfigNeth */
