/* sysLibExtra.h - More system library functions unique to the ppc405_0 BSP */

/*******************************************************************************
   XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
   AS A COURTESY TO YOU, SOLELY FOR USE IN DEVELOPING PROGRAMS AND
   SOLUTIONS FOR XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE,
   OR INFORMATION AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
   APPLICATION OR STANDARD, XILINX IS MAKING NO REPRESENTATION
   THAT THIS IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
   AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
   FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
   WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
   IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
   REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
   INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
   FOR A PARTICULAR PURPOSE.

   (c) Copyright 2003-2006 Xilinx Inc.
   All rights reserved.
*******************************************************************************/

/*

TODO - Start a new revision history

modification history
--------------------
01a,18feb03,rmm  Ported from ML300 version 01b
01b,30may06,rmm  CR230411: Added definition of cacheArchFlush_ppc405_revD_and_up
*/

/*

DESCRIPTION
This file defines routines unique to the ppc405_0 evaluation board that do
not fall into major catagories.

*/

#ifndef _sysLibExtra_h_
#define _sysLibExtra_h_

#include "vxWorks.h"
#include "cacheLib.h"

/*
 * Delay routines. Busy loop delays that do not relinquish the CPU
 */
void sysMsDelay(UINT32 delay);
void sysUsDelay(UINT32 delay);


/*
 * System ACE functions
 */
void   sysSystemAceInitFS(void);
STATUS sysSystemAceMount(unsigned short aceDeviceId, char* mountpoint, int partition);
STATUS sysSystemAceSetJtagConfigAddr(unsigned configAddr);
STATUS sysSystemAceJtagReboot(unsigned long baseAddr);


/*
 * misc
 */
void sysCspBootErrorLogShow(void);
STATUS cacheArchFlush_ppc405_revD_and_up(CACHE_TYPE cache, void *address, size_t bytes);

/* TODO - Add other board prototype functions here */

#endif  /* _sysLibExtra_h_ */
